/*******************************************************************************
* Copyright 2005-2016 Intel Corporation All Rights Reserved.
*
* The source code,  information  and material  ("Material") contained  herein is
* owned by Intel Corporation or its  suppliers or licensors,  and  title to such
* Material remains with Intel  Corporation or its  suppliers or  licensors.  The
* Material  contains  proprietary  information  of  Intel or  its suppliers  and
* licensors.  The Material is protected by  worldwide copyright  laws and treaty
* provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
* modified, published,  uploaded, posted, transmitted,  distributed or disclosed
* in any way without Intel's prior express written permission.  No license under
* any patent,  copyright or other  intellectual property rights  in the Material
* is granted to  or  conferred  upon  you,  either   expressly,  by implication,
* inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
* property rights must be express and approved by Intel in writing.
*
* Unless otherwise agreed by Intel in writing,  you may not remove or alter this
* notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
* suppliers or licensors in any way.
*******************************************************************************/

/*
! Content:
!       MKL Cluster DFT example's definitions file (C-interface)
!
!****************************************************************************/

/*
**  Print level definition
*/
#define ADVANCED_DATA_PRINT 1
#define ACCURACY_PRINT 1
#define LEGEND_PRINT 1

/*
**  Accuracy definitions
*/
#define SINGLE_EPS 1.0E-6
#define DOUBLE_EPS 1.0E-12

/*
**  MKL test _Complex type definition
*/
typedef struct {
    float re;
    float im;
} mkl_float_complex;

typedef struct {
    double re;
    double im;
} mkl_double_complex;

/*
**  Example support function's interfaces
*/
int read_data_file_2d(int, char*[], long*, long*);

void dfti_example_status_print(int, long);

void print_data_2d_z(void*, long, long, long);

void init_data_2d_z(void*, long, long);

double check_result_z(void*, void*, long);

void print_data_2d_c(void*, long, long, long);

void init_data_2d_c(void*, long, long);

float check_result_c(void*, void*, long);

int MKL_CDFT_Data(MPI_Comm Comm,int RootRank,int ElementSize,long Dim,
                  MKL_LONG Lengths[],void *global,long nx,long start_x,void *local,
                  int Flag);

int MKL_CDFT_ScatterData(MPI_Comm Comm,int RootRank,int ElementSize,long Dim,
                         MKL_LONG Lengths[],void *global_in,long nx,long start_x,
                         void *local_in);

int MKL_CDFT_GatherData(MPI_Comm Comm,int RootRank,int ElementSize,long Dim,
                        MKL_LONG Lengths[],void *global_out,long nx,long start_x,
                        void *local_out);
